
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class OrdersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const orders = await db.orders.create(
            {
                id: data.id || undefined,
        
        order_channel: data.order_channel
        ||
        null
            ,
            
        fulfillment_type: data.fulfillment_type
        ||
        null
            ,
            
        delivery_address: data.delivery_address
        ||
        null
            ,
            
        delivery_latitude: data.delivery_latitude
        ||
        null
            ,
            
        delivery_longitude: data.delivery_longitude
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        ordered_at: data.ordered_at
        ||
        null
            ,
            
        requested_for: data.requested_for
        ||
        null
            ,
            
        customer_note: data.customer_note
        ||
        null
            ,
            
        subtotal_amount: data.subtotal_amount
        ||
        null
            ,
            
        total_amount: data.total_amount
        ||
        null
            ,
            
        is_paid: data.is_paid
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await orders.setRestaurant( data.restaurant || null, {
            transaction,
        });
        
        await orders.setClient_user( data.client_user || null, {
            transaction,
        });
        
        await orders.setTable( data.table || null, {
            transaction,
        });
        

        

        

        return orders;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ordersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                order_channel: item.order_channel
            ||
            null
            ,
            
                fulfillment_type: item.fulfillment_type
            ||
            null
            ,
            
                delivery_address: item.delivery_address
            ||
            null
            ,
            
                delivery_latitude: item.delivery_latitude
            ||
            null
            ,
            
                delivery_longitude: item.delivery_longitude
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                ordered_at: item.ordered_at
            ||
            null
            ,
            
                requested_for: item.requested_for
            ||
            null
            ,
            
                customer_note: item.customer_note
            ||
            null
            ,
            
                subtotal_amount: item.subtotal_amount
            ||
            null
            ,
            
                total_amount: item.total_amount
            ||
            null
            ,
            
                is_paid: item.is_paid
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const orders = await db.orders.bulkCreate(ordersData, { transaction });

        // For each item created, replace relation files
        

        return orders;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const orders = await db.orders.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.order_channel !== undefined) updatePayload.order_channel = data.order_channel;
        
        
        if (data.fulfillment_type !== undefined) updatePayload.fulfillment_type = data.fulfillment_type;
        
        
        if (data.delivery_address !== undefined) updatePayload.delivery_address = data.delivery_address;
        
        
        if (data.delivery_latitude !== undefined) updatePayload.delivery_latitude = data.delivery_latitude;
        
        
        if (data.delivery_longitude !== undefined) updatePayload.delivery_longitude = data.delivery_longitude;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.ordered_at !== undefined) updatePayload.ordered_at = data.ordered_at;
        
        
        if (data.requested_for !== undefined) updatePayload.requested_for = data.requested_for;
        
        
        if (data.customer_note !== undefined) updatePayload.customer_note = data.customer_note;
        
        
        if (data.subtotal_amount !== undefined) updatePayload.subtotal_amount = data.subtotal_amount;
        
        
        if (data.total_amount !== undefined) updatePayload.total_amount = data.total_amount;
        
        
        if (data.is_paid !== undefined) updatePayload.is_paid = data.is_paid;
        
        
        updatePayload.updatedById = currentUser.id;

        await orders.update(updatePayload, {transaction});

        
        
        if (data.restaurant !== undefined) {
            await orders.setRestaurant(
              
              data.restaurant,
              
              { transaction }
            );
        }
        
        if (data.client_user !== undefined) {
            await orders.setClient_user(
              
              data.client_user,
              
              { transaction }
            );
        }
        
        if (data.table !== undefined) {
            await orders.setTable(
              
              data.table,
              
              { transaction }
            );
        }
        

        
        

        

        return orders;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const orders = await db.orders.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of orders) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of orders) {
                await record.destroy({transaction});
            }
        });


        return orders;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const orders = await db.orders.findByPk(id, options);

        await orders.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await orders.destroy({
            transaction
        });

        return orders;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const orders = await db.orders.findOne(
            { where },
            { transaction },
        );

        if (!orders) {
            return orders;
        }

        const output = orders.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.order_items_order = await orders.getOrder_items_order({
            transaction
        });
        
        
        
        output.payments_order = await orders.getPayments_order({
            transaction
        });
        
        
        
        
        
        output.customer_reviews_order = await orders.getCustomer_reviews_order({
            transaction
        });
        
        
        
        
        
        
        output.invoices_order = await orders.getInvoices_order({
            transaction
        });
        
        
        
        
        output.restaurant = await orders.getRestaurant({
            transaction
        });
        
        
        output.client_user = await orders.getClient_user({
            transaction
        });
        
        
        output.table = await orders.getTable({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.restaurants,
        as: 'restaurant',
        
        where: filter.restaurant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.restaurant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.restaurant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'client_user',
        
        where: filter.client_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.client_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.client_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.restaurant_tables,
        as: 'table',
        
        where: filter.table ? {
          [Op.or]: [
            { id: { [Op.in]: filter.table.split('|').map(term => Utils.uuid(term)) } },
            {
              table_label: {
                [Op.or]: filter.table.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.delivery_address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'orders',
                        'delivery_address',
                        filter.delivery_address,
                    ),
                };
            }
            
            if (filter.customer_note) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'orders',
                        'customer_note',
                        filter.customer_note,
                    ),
                };
            }
            

            
            

            
            if (filter.delivery_latitudeRange) {
                const [start, end] = filter.delivery_latitudeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    delivery_latitude: {
                    ...where.delivery_latitude,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    delivery_latitude: {
                    ...where.delivery_latitude,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.delivery_longitudeRange) {
                const [start, end] = filter.delivery_longitudeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    delivery_longitude: {
                    ...where.delivery_longitude,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    delivery_longitude: {
                    ...where.delivery_longitude,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.ordered_atRange) {
                const [start, end] = filter.ordered_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ordered_at: {
                    ...where.ordered_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ordered_at: {
                    ...where.ordered_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.requested_forRange) {
                const [start, end] = filter.requested_forRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    requested_for: {
                    ...where.requested_for,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    requested_for: {
                    ...where.requested_for,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.subtotal_amountRange) {
                const [start, end] = filter.subtotal_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    subtotal_amount: {
                    ...where.subtotal_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    subtotal_amount: {
                    ...where.subtotal_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_amountRange) {
                const [start, end] = filter.total_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_amount: {
                    ...where.total_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_amount: {
                    ...where.total_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.order_channel) {
                where = {
                    ...where,
                order_channel: filter.order_channel,
            };
            }
            
            if (filter.fulfillment_type) {
                where = {
                    ...where,
                fulfillment_type: filter.fulfillment_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.is_paid) {
                where = {
                    ...where,
                is_paid: filter.is_paid,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.orders.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'orders',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.orders.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

